;****************************************************************
;*								*
;*	ST-SYS II:						*
;*	System resident ST pour recevoir des commandes PC.	*
;*	(C)OXYGENE 1995-96 by Leonard.				*
;*								*
;*								*
;****************************************************************
GEMDOS		equ	1
LDEBUG		equ	1
COMMAND_SIZE	equ	32
BLOCK_SIZE	equ	2048

XBIOS_READ	equ	8
XBIOS_WRITE	equ	9

CMD_BLOCKLOAD	equ	0
CMD_LOADANDRUN	equ	1
CMD_BLOCKRUN	equ	2
CMD_BLOCKSAVE	equ	3
CMD_FILECOPY	equ	4
CMD_DISKIMAGE	equ	5

BSTE		equ	0
BINARYOK	equ	1
SCREEN		equ	2
REGS		equ	6
TOWERAD		equ	(6+48)


	;******************************************************
	; Partie a executer sur ST.
	; (Ecriture du boot secteur et du fichier "LEO_PC.SYS")
	;******************************************************

		clr.l	-(sp)
		move.w	#32,-(sp)
		trap	#1

		pea	txt_intro(pc)
		move.w	#9,-(sp)
		trap	#1
		move.w	#7,-(sp)
		trap	#1
		addq.l	#8,sp
		cmpi.b	#'e',d0
		beq.s	Write

		clr.w	-(sp)
		trap	#1

Write:		pea	txt_write(pc)
		move.w	#9,-(sp)
		trap	#1
		addq.l	#6,sp
		clr.l	$200-8.w

	;--------------------------------------------
	; Write boot sector.
	;--------------------------------------------
		bsr	Write_Boot

	;--------------------------------------------
	; Write system
	;--------------------------------------------
		bsr	Write_Sys

	;--------------------------------------------
	; Return to GEM.
	;--------------------------------------------
		lea	txt_presskey,a0
		bsr	ins_print

		move.w	#7,-(sp)
		trap	#1
		addq.w	#2,sp

		clr.w	-(sp)
		trap	#1


;************************************************************************
; FONCTIONS
;************************************************************************
ins_print	pea	(a0)
		move.w	#9,-(sp)
		trap	#1
		addq.l	#6,sp
		rts


Write_Boot
		move.w	#(finboot-My_Boot),d0
		cmpi.w	#480-2,d0
		bls.s	.ok

		lea	txt_boottroplong,a0
		bsr	ins_print
		rts

.ok:		lea	txt_writeboot,a0
		bsr	ins_print

		lea	boot_buffer,a0
		moveq	#0,d0		; piste
		moveq	#0,d1		; face
		moveq	#1,d2		; 1 secteur
		moveq	#XBIOS_READ,d3
		bsr	Track_Acces
		lea	My_Boot,a0
		lea	boot_buffer,a1
		move.w	#$601e,(a1)	; BRA.S du boot.
		lea	32(a1),a1
		moveq	#480/4-1,d0
.copy:		move.l	(a0)+,(a1)+
		dbf	d0,.copy
		lea	boot_buffer,a0
		moveq	#0,d0
		move.w	#510/2-1,d1
.count:		add.w	(a0)+,d0
		dbf	d1,.count
		move.w	#$1234,d1
		sub.w	d0,d1
		move.w	d1,(a0)
		lea	boot_buffer,a0
		moveq	#0,d0		; piste
		moveq	#0,d1		; face
		moveq	#1,d2		; 1 secteur
		moveq	#XBIOS_WRITE,d3
		bsr	Track_Acces
		rts




Write_Sys



	;---------------------------------------------------
	; Cre le checksum du system
	;---------------------------------------------------
		lea	codeStart(pc),a0
		move.w	#(codeEnd-codeStart-2)/2-1,d0
		moveq	#0,d1
.calc:		add.w	(a0)+,d1
		dbf	d0,.calc
		neg	d1
		move.w	d1,checksumModify


	;---------------------------------------------------
		lea	txt_writesys,a0
		bsr	ins_print
		clr.w	-(sp)		; Attribut normal.
		pea	sysname
		move.w	#$3c,-(sp)	; FCREATE
		trap	#1
		addq.l	#8,sp
		tst.l	d0
		bpl.s	.ok
		lea	txt_writesyserror,a0
		bsr	ins_print
		rts
.ok:		move.w	d0,d7			; handle
		pea	codeStart		; Adresse buffer.
		move.l	#(codeEnd-codeStart),-(sp)	; Taille system.
		move.w	d7,-(sp)
		move.w	#$40,-(sp)		; FWRITE
		trap	#1
		lea	12(sp),sp
		move.w	d7,-(sp)
		move.w	#$3e,-(sp)		; FCLOSE
		trap	#1
		addq.l	#4,sp
		rts



; D0: Track
; D1: Side
; D2: Nb sector
; D3: Command (8=read,9=write)
; A0: Buffer adress.
Track_Acces	cmpi.w	#XBIOS_READ,d3
		beq.s	.ok
		cmpi.w	#XBIOS_WRITE,d3
		bne.s	.non
.ok:		and.w	#1,d1
		move.w	d2,-(sp)	; Count
		move.w	d1,-(sp)	; Side
		move.w	d0,-(sp)	; Track
		move.w	#1,-(sp)	; Secteur deb
		clr.w	-(sp)		; Drive A:
		clr.l	-(sp)
		pea	(a0)		; buffer
		move.w	d3,-(sp)	; Command
		trap	#14
		lea	20(sp),sp
.non:		rts



txt_intro
		dc.b	27,'E'
		dc.b	'ATARI-PC system installator.',10,13
		dc.b	'(C)OXYGENE 95-96 by Leonard.',10,13,10,13
		dc.b	'Ce prog va creer un boot secteur',10,13
		dc.b	'et un fichier LEO_PC.SYS sur la',10,13
		dc.b	'disquette A:',10,13
		dc.b	'Appuyez sur "e" pour ecrire.',10,13,7,0

txt_write	dc.b	'Writing system...',10,13,0
txt_error	dc.b	'Error on writing track 80,10 sectors.',10,13,0
txt_size	dc.b	'ERROR: System is too large.',10,13,0
txt_boottroplong
		dc.b	'BOOT trop long. ( >  478 octets).',10,13,0
txt_writeboot
		dc.b	'Ecriture du boot-secteur...',10,13,0
txt_writesys
		dc.b	'Creation du fichier system LEO_PC.SYS',10,13,0
txt_writesyserror
		dc.b	'ERROR in writing LEO_PC.SYS',10,13,0
txt_presskey
		dc.b	10,13
		dc.b	'Press a key to return to GEM.',10,13,0


		even


boot_buffer	ds.b	512








;********************************************************************
;********************************************************************
;********************************************************************
;********************************************************************


;**************************************
;
;	Boot Secteur system.
;
;**************************************

My_Boot
		addq.l	#4,4(sp)		; Skip le BSR du wait disk dur en ROM.
						; (fast boot).
		cmpi.l	#'LEO!',$200.w
		bne.s	boot_sys

nosys:		clr.l	$200.w
		lea	normaltxt(pc),a0
		move.l	#'FIRS',$204.w

bprint		pea	(a0)
		move.w	#9,-(sp)
		trap	#1
		addq.l	#6,sp
		rts

boot_sys:
		lea	sysloadtxt(pc),a0
		bsr.s	bprint

	;------------------------------------------------------
	;	Fast load.
	;------------------------------------------------------
		cmpi.l	#'LEO!',($200-8).w
		bne.s	.loading
		move.l	($200-4).w,a6		; Adresse du bin.
		cmpi.l	#'LeOn',2(a6)		; Second check
		bne.s	.loading
		jmp	(a6)

	;------------------------------------------------------
	; Lecture du fichier system.
	;------------------------------------------------------
.loading:	clr.w	-(sp)		; Lecture uniquement.
		pea	sysname(pc)
		move.w	#$3d,-(sp)	; FOPEN
		trap	#1
		addq.l	#8,sp
		tst.l	d0
		bpl.s	.ok
		lea	errortxt(pc),a0
		bsr.s	bprint
		bra.s	nosys

.ok:		move.w	d0,d7		; handle
		move.l	$436.w,a6	; Max memoire utilisateur.
		sub.l	#(bssEnd-codeStart),a6
		pea	(a6)
		pea	(codeEnd-codeStart)	; Taille maxi a charger.
		move.w	d7,-(sp)	; handle
		move.w	#$3f,-(sp)	; FREAD
		trap	#1
		lea	12(sp),sp
		move.l	d0,d6		; Taille reelle du system
		move.w	d7,-(sp)	; handle
		move.w	#$3e,-(sp)	; FCLOSE
		trap	#1
		addq.l	#4,sp

		lea	$200.w,a0
		move.l	#'LEO!',-8(a0)
		move.l	a6,-4(a0)
		move.l	#'FIRS',4(a0)
		jmp	(a6)

hellotxt	dc.b	27,'E'
		dc.b	'ATARI-PC system.',10,13
		dc.b	'(C)OXYGENE 1995 by Leonard.',10,13,10,13,0

errortxt	dc.b	7,'LEO_PC.SYS not found.',10,13,0

normaltxt
		dc.b	'SYSTEM skipped, starting',10,13
		dc.b	'normal ST boot...',0

sysloadtxt	dc.b	'Installing, please wait.',10,13,0

sysname		dc.b	'LEO_PC.SYS',0

		even
finboot:
	rept	480/8
	dc.b	'LEONARD!'
	endr
	even


;************************************************************************

;************************************************************************


codeStart:
		bra.s	.debut
		dc.b	'LeOnArD!'
.debut:		move.w	#$2700,sr
		lea	stack(pc),sp
	IFNE	LDEBUG
		bsr	lDebug		; Ne modifie pas le checksum entre codeStart et codeEnd
	ENDC

	;--------------------------------------
	; Avant toute chose on check le
	; checksum du code.
	;--------------------------------------
		lea	codeStart(pc),a0
		move.w	#(codeEnd-codeStart)/2-1,d0
		moveq	#0,d1
.calc:		add.w	(a0)+,d1
		dbf	d0,.calc
		tst.w	d1
		bne	checksumError

	;--------------------------------------
	; Premier lancement ?
	;--------------------------------------
		cmpi.l	#'FIRS',$204.w
		bne.s	.noFirst
		lea	rsZone(pc),a6
		lea	REGS(a6),a6
		move.w	#$2700,sr
		move.l	$70.w,(a6)+
		move.l	$114.w,(a6)+
		move.l	$118.w,(a6)+
		move.l	$11c.w,(a6)+
		move.l	$120.w,(a6)+
		move.l	$134.w,(a6)+
		clr.l	(a6)+
		clr.l	(a6)+
		moveq	#16-1,d0
		movea.w	#$fa01,a0
.l1:		move.b	(a0),(a6)+
		addq.w	#2,a0
		dbf	d0,.l1
		clr.l	$204.w
		lea	oldTrap(pc),a0
		move.l	$84.w,(a0)


	;--------------------------------------
	; Init system.
	;--------------------------------------
.noFirst:	addq.l	#1,$204.w
		lea	rsZone(pc),a6
		lea	REGS(a6),a6
		move.w	#$2700,sr
		move.l	(a6)+,$70.w
		move.l	(a6)+,$114.w
		move.l	(a6)+,$118.w
		move.l	(a6)+,$11c.w
		move.l	(a6)+,$120.w
		move.l	(a6)+,$134.w
		tst.l	(a6)+
		tst.l	(a6)+
		moveq	#16-1,d0
		movea.w	#$fa01,a0
.l2:		move.b	(a6)+,(a0)
		addq.w	#2,a0
		dbf	d0,.l2



	;--------------------------------------
	; STE ou STF ?
	;--------------------------------------
		bsr	isSte
		lea	rsZone(pc),a6
		move.b	d0,BSTE(a6)


	;--------------------------------------
	; Config mmoire.
	;--------------------------------------
		lea	codeStart(pc),a0
		move.l	a0,d0
		subi.l	#32000,d0
		sf	d0
		move.l	d0,SCREEN(a6)
		subi.l	#((20*BLOCK_SIZE/2)+8),d0
		move.l	d0,TOWERAD(a6)

	;--------------------------------------
	; Init les ecrans:
	;--------------------------------------
		move.l	SCREEN(a6),a0
		moveq	#1,d0
		bsr	screenInit


	;--------------------------------------
	; Welcome
	;--------------------------------------
		bsr	printSysInfo


	;--------------------------------------
	; Construit le code de reception.
	;--------------------------------------
		bsr	towerBuild


		lea	rsZone(pc),a6
		sf	BINARYOK(a6)

	;--------------------------------------
	;--------------------------------------
waitingCommand:
		move.l	#'LEO!',$200.w
		lea	txtWaitCommand(pc),a0
		bsr	print

		bsr	commandReceive
		bmi.s	commandError

		clr.l	$200.w

		pea	waitingCommand(pc)	; Retour par RTS.

	; Switch-Case

		cmpi.w	#CMD_LOADANDRUN,d0
		beq	loadAndRun
		cmpi.w	#CMD_BLOCKRUN,d0
		beq	blockRun
		cmpi.w	#CMD_BLOCKLOAD,d0
		beq	blockLoad
		cmpi.w	#CMD_BLOCKSAVE,d0
		beq	blockSave
		cmpi.w	#CMD_FILECOPY,d0
		beq	fileCopy
		cmpi.w	#CMD_DISKIMAGE,d0
		beq	diskImage

	; Default:
		lea	txtUnknowCommand(pc),a0
		bsr	print
		rts				; Retour a waitingCommand

commandError	lea	txtCommandError(pc),a0
		bsr	print
		bra	waitingCommand


; D0: Track
; D1: Side
; D2: Nb sector
; D3: Command (8=read,9=write)
; d4: Nb de pistes.
; d5: nb de faces (1 ou 2)
; A0: Buffer adress.
TrackWork:	and.w	#1,d1		; side.

		mulu.w	d5,d4		; d4=nb de cylindres.
		subq.w	#1,d4

.trackLoop:	movem.l	d0-a6,-(sp)
		move.w	d2,-(sp)	; Count
		move.w	d1,-(sp)	; Side
		move.w	d0,-(sp)	; Track
		move.w	#1,-(sp)	; Secteur deb
		clr.w	-(sp)		; Drive A:
		clr.l	-(sp)
		pea	(a0)		; buffer
		move.w	d3,-(sp)	; Command
		trap	#14
		lea	20(sp),sp
		movem.l	(sp)+,d0-a6
		cmpi.w	#1,d5		; si une seule face
		beq.s	.next		; on change de cylindre.
		eori.w	#1,d1		; change la side.
		bne.s	.ok
.next:		addq.w	#1,d0		; un cylindre.
.ok:		move.w	d2,d7
		add.w	d7,d7
		lsl.w	#8,d7		; nb sect*512
		add.w	d7,a0
		dbf	d4,.trackLoop
.non:		rts


checksumError:	moveq	#-1,d0
.loop:		move.w	d0,$ffff8240.w
		dbf	d0,.loop

stBoot:		clr.l	$426.w
;		move.l	#'LEO!',$200.w
		clr.l	($200-8).w
		move.l	$4.w,a0
		jmp	(a0)


debug:
		lea	rsZone(pc),a6
		move.l	SCREEN(a6),a0
		moveq	#0,d0
		bsr	screenInit

		clr.w	$ffff8240.w
		move.w	#$777,$ffff8242.w
		move.w	#$004,$ffff8244.w

		move.w	#$2300,sr
wait:		move.l	$466.w,d0
.vsync:		cmp.l	$466.w,d0
		beq.s	.vsync
		lea	rsZone(pc),a6
		move.l	SCREEN(a6),a0
		lea	160*16(a0),a0
		moveq	#0,d0
		move.w	#160*16/4-1,d1
.cls:		move.l	d0,-(a0)
		dbf	d1,.cls

		moveq	#16-1,d1
		move.w	$ffff9202.w,d0	; Ports joystick.
.draw:		moveq	#0,d2
		add.w	d0,d0
		bcs.s	.no
		moveq	#2,d2
.no:

		lea	0(a0,d2.w),a1
i		set	0
		rept	15
		move.w	#$fffe,i(a1)
i		set	i+160
		endr
		addq.w	#8,a0

		dbf	d1,.draw

		cmp.b	#57,$fffffc02.w
		bne	wait
.flush:		cmp.b	#57,$fffffc02.w
		beq.s	.flush

		bra	codeStart


;********************************************************
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;********************************************************
READ_WAIT_MI	macro
		move.w	(a5),d0		; 02
		bmi.s	*-2		; 02
		move.w	(a5),d0		; 02
		bmi.s	*-6		; 02
		endm
READ_WAIT_PL	macro
		move.w	(a5),d0		; 02
		bpl.s	*-2		; 02
		move.w	(a5),d0		; 02
		bpl.s	*-6
;		bpl.s	*-2
		endm

towerBuild:	movem.l	d0-a6,-(sp)
		lea	rsZone(pc),a6
		move.l	TOWERAD(a6),a1

		move.w	#BLOCK_SIZE/2-1,d0
.loop:		lea	.sample(pc),a0
		moveq	#20/2-1,d1
.loop2:		move.w	(a0)+,(a1)+
		dbf	d1,.loop2
		dbf	d0,.loop
		move.w	.sample2(pc),(a1)+
		move.w	.sample3(pc),(a1)+
		move.l	TOWERAD(a6),d0
		sub.l	a1,d0
		move.w	d0,(a1)+
		move.w	.sample4(pc),(a1)+
		movem.l	(sp)+,d0-a6
		rts

.sample:	READ_WAIT_MI
		move.b	d0,(a0)+
		READ_WAIT_PL
		move.b	d0,(a0)+
.sample2:	subq.l	#1,d7
.sample3:	bne.w	.sample3
.sample4:	jmp	(a2)



;********************************************************
;*							*
;* 	fastBlockReceive				*
;*	Reception d'un block binaire du PC.		*
;*							*
;*	Input:	A0: Adresse de reception.		*
;*		D0: Taille du block en octets.		*
;*							*
;********************************************************

fastBlockReceive:
		movem.l	d0-d7/a0-a6,-(sp)
		move.w	$ffff8244.w,-(sp)
		move.l	d0,d7
		add.l	#BLOCK_SIZE-1,d7
	IFEQ	(BLOCK_SIZE-2048)
		moveq	#11,d0
		lsr.l	d0,d7		; Nb de blocks de BLOCK_SIZE
	ELSEIF
		fail	"Code a modifier si chg de BLOCK_SIZE"
	ENDC
		move.w	#$2700,sr
		movea.w	#$9202,a5

		move.w	#$f00,$ffff8244.w

		lea	rsZone(pc),a6
		move.l	TOWERAD(a6),a6
		lea	.back(pc),a2
		jmp	(a6)
.back:
	      	move.w	#$2300,sr
		move.w	(sp)+,$ffff8244.w
		movem.l	(sp)+,d0-d7/a0-a6
		rts


;********************************************************
;*							*
;* 	commandReceive					*
;*	Reception d'une commande PC.			*
;*							*
;*	Input:	Nothing					*
;*	Return:	D0 <  0: Wrong command.			*
;*		D0 >= 0: Command number.		*
;*							*
;********************************************************
commandReceive:	movem.l	d1-a6,-(sp)

		lea	rsZone(pc),a6
		move.l	SCREEN(a6),a0
		lea	156(a0),a0

		moveq	#8-1,d0
.loop1:		move.l	#$0000ffff,(a0)
		lea	160(a0),a0
		dbf	d0,.loop1

		lea	commandBuffer(pc),a0
		moveq	#32/2-1,d7
		movea.w	#$9202,a5

		move.w	#$2700,sr

.wait:		addq.w	#1,$ffff8244.w
		move.b	$fffffc02.w,d0
		cmpi.b	#1,d0
		beq	stBoot
		cmpi.b	#$44,d0
		beq	debug
		move.w	(a5),d0
		bmi.s	.wait

.read:		READ_WAIT_MI
		move.b	d0,(a0)+
		READ_WAIT_PL
		move.b	d0,(a0)+
		dbf	d7,.read

		clr.w	$ffff8244.w

		lea	commandBuffer(pc),a0
		moveq	#31-1,d0
		moveq	#0,d1
.chk:		move.b	(a0)+,d2
		eor.b	d2,d1
		dbf	d0,.chk
		cmp.b	(a0)+,d1
		beq.s	.ok
		moveq	#-1,d0
		bra.s	.over

.ok:
		lea	commandBuffer(pc),a2
		move.w	10(a2),d0

		cmpi.w	#CMD_BLOCKRUN,d0
		beq.s	.noCopy
		cmpi.w	#CMD_BLOCKSAVE,d0
		beq.s	.noCopy

		lea	binarySize(pc),a1
		move.l	(a2)+,(a1)+		; size
		move.w	(a2)+,(a1)+		; checksum
		move.l	(a2)+,(a1)+		; adress
		move.w	(a2)+,(a1)+		; Command number.
		addq.l	#4,a2
		lea	fName(pc),a1
		move.l	(a2)+,(a1)+
		move.l	(a2)+,(a1)+
		move.l	(a2)+,(a1)+
		move.l	(a2)+,(a1)+

.noCopy:

.over:		move.w	#$2300,sr
		movem.l	(sp)+,d1-a6
		tst.w	d0
		rts









;********************************************************
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;********************************************************
loadAndRun:	bsr	blockLoad
		bsr.s	blockRun
		rts



;********************************************************
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;********************************************************
blockRun:	lea	rsZone(pc),a0
		tst.b	BINARYOK(a0)
		bne.s	.execute
		lea	txtBinaryNoOk(pc),a0
		bsr	print
		rts
.execute:
		lea	myTrap(pc),a0
		move.l	a0,$84.w
		move.w	#$2300,sr
		move.l	binaryAd(pc),a0
		jmp	(a0)

myTrap:		move.w	6(sp),d0
		bne.s	.oldJmp
		move.w	#$2300,sr
		addq.l	#6+2,sp
		bra	codeStart
.oldJmp:	move.l	oldTrap(pc),a0
		jmp	(a0)




;********************************************************
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;********************************************************
blockLoad:	lea	txtBlockLoad(pc),a0
		bsr	print
		bsr	uploadBlock
		rts




;********************************************************
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;********************************************************
blockSave:	lea	rsZone(pc),a6
		tst.b	BINARYOK(a6)
		bne.s	.ok
		lea	txtBinaryNoOk(pc),a0
		bsr	print
		rts

.ok:		lea	txtBlockSave(pc),a0
		bsr	print
		lea	fName(pc),a0
		bsr	print
		lea	.txtDaube(pc),a0
		bsr	print
		lea	fName(pc),a0
		bsr.s	writeFile
		rts
.txtDaube	dc.b	'"',10,13,0
		even

writeFile:	clr.w	-(sp)		; Attribut normal.
		pea	(a0)		; Nom du fichier
		move.w	#$3c,-(sp)	; FCREATE
		trap	#1
		addq.l	#8,sp
		tst.l	d0
		bmi.s	.error
		move.w	d0,d7		; handle
		move.l	binaryAd(pc),-(sp)
		move.l	binarySize(pc),-(sp)
		move.w	d7,-(sp)
		move.w	#$40,-(sp)		; FWRITE
		trap	#1
		lea	12(sp),sp
		tst.l	d0
		bmi.s	.error
		move.w	d7,-(sp)
		move.w	#$3e,-(sp)		; FCLOSE
		trap	#1
		addq.l	#4,sp
		tst.l	d0
		bmi.s	.error
		rts

.error:		lea	txtXbiosWriteError(pc),a0
		bsr	print
		rts



;********************************************************
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;********************************************************
diskImage:
		bsr	blockLoad

		lea	rsZone(pc),a6
		tst.b	BINARYOK(a6)
		bne.s	.ok
		lea	txtBinaryNoOk(pc),a0
		bsr	print
		rts

.ok:		lea	txtDiskCreate(pc),a0
		bsr	print
;		move.l	binarySize(pc),d0

		move.l	binaryAd(pc),a0
;		move.b	12(a0),d0
;		lsl.w	#8,d0
;		move.b	11(a0),d0
;		cmpi.w	#512,d0
;		bne	boot_error
		move.b	25(a0),d0
		lsl.w	#8,d0
		move.b	24(a0),d0		; Nb sector par piste
		move.b	27(a0),d1
		lsl.w	#8,d1
		move.b	26(a0),d1		; Nb side
.ok1:		move.b	20(a0),d2
		lsl.w	#8,d2
		move.b	19(a0),d2		; Nb secteur total
		move.w	d2,d3
		ext.l	d3
		divu.w	d1,d3			; Nb de secteur pour 1 face.
		ext.l	d3
		divu.w	d0,d3			; Nb de pistes

		move.w	d1,d5			; nb de piste
		move.w	d0,d2			; nb secteur
		move.w	d3,d4			; nb de track
		moveq	#9,d3			; command WRITE
		moveq	#0,d0			; piste
		moveq	#0,d1			; side
		move.l	binaryAd(pc),a0
		bsr	TrackWork

		rts


;********************************************************
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;********************************************************
fileCopy	bsr	blockLoad
		bsr	blockSave
		rts






;********************************************************
;*							*
;*	uploadBlock					*
;*							*
;*	Input: Nothing					*
;*	Output:	D0.w = 0 : Ok.				*
;*		D0.w < 0 : Checksum error.		*
;*							*
;********************************************************
uploadBlock:	movem.l	d1-a6,-(sp)
		bsr	printBlockInfos
		move.l	binarySize(pc),d0
		move.l	binaryAd(pc),a0
		bsr	fastBlockReceive
		lea	txtCalcChecksum(pc),a0
		bsr	print
		move.w	#$060,$ffff8244.w
		move.l	binaryAd(pc),a0
		move.l	binarySize(pc),d7
		moveq	#0,d0
		moveq	#0,d1
.chk:		move.b	(a0)+,d0
		add.w	d0,d1
		subq.l	#1,d7
		bne.s	.chk
		clr.w	$ffff8244.w
		move.w	binaryCheck(pc),d0
		lea	rsZone(pc),a6
		st	BINARYOK(a6)
		sub.w	d1,d0			; d0 doit etre = d1
		beq.s	.checkOk
		lea	txtChecksumError(pc),a0
		bsr	print
		sf	BINARYOK(a6)
		moveq	#-1,d0
.checkOk:	movem.l	(sp)+,d1-a6
		tst.l	d0
		rts


printBlockInfos
		lea	.txt(pc),a0
		bsr	print
		move.l	binarySize(pc),d0
		bsr	printNumber
		lea	.txt2(pc),a0
		bsr	print
		move.l	binaryAd(pc),d0
		bsr	printNumber
		lea	.txt3(pc),a0
		bsr	print
		rts

.txt:		dc.b	'Loading $',0
.txt2:		dc.b	' bytes at $',0
.txt3:		dc.b	' adress...',10,13,0
		even


;********************************************************
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;********************************************************
printSysInfo	lea	rsZone(pc),a6
		lea	.txtb0(pc),a0
		bsr	print
		lea	codeStart(pc),a0
		move.l	a0,d0
		bsr	printNumber
		lea	.txtb1(pc),a0
		bsr	print
		rts

.txtb0:		dc.b	27,'E'
		dc.b	'ATARI-PC Development system.',10,13
		dc.b	'(c)OXYGENE 1995 by Leonard.',10,13,10,13
		dc.b	'System located at $',0
.txtb1:		dc.b	10,13
		dc.b	'(Leonard-Debugger present)',10,13,0
		even

printNumber	movem.l	d1-d2,-(sp)
		lea	tmpPrint(pc),a0
		moveq	#8-1,d1
.loop:		rol.l	#4,d0
		moveq	#15,d2
		and.w	d0,d2
		move.b	.tab(pc,d2.w),(a0)+
		dbf	d1,.loop
		clr.b	(a0)+
		movem.l	(sp)+,d1-d2
		lea	tmpPrint(pc),a0
		bra	print
.tab:		dc.b	'0123456789ABCDEF'
		even




;********************************************************
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;********************************************************
print:
	IFNE	GEMDOS
		pea	(a0)
		move.w	#9,-(sp)
		trap	#1
		addq.l	#6,sp
	ENDC
		rts




;********************************************************
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;*							*
;********************************************************
getch:
	IFNE	GEMDOS
		move.w	#7,-(sp)
		trap	#1
		addq.w	#2,sp
	ELSEIF
		movem.w	d0-d1,-(sp)
		move.b	$fffffc02.w,d0
.loop:		move.b	$fffffc02.w,d1
		cmpi.b	d1,d0
		beq.s	.loop
.loop2:		cmp.b	$fffffc02.w,d1
		beq.s	.loop2
		movem.w	(sp)+,d0-d1
	ENDC
		rts




;********************************************************
;*							*
;*	screenInit					*
;*							*
;* 	Init un ecran.					*
;*	Input:	A0: Screen Adress.			*
;*		d0: Resolution.				*
;*							*
;*							*
;********************************************************
screenInit	movem.l	d0-d1/a0,-(sp)
	IFEQ	GEMDOS
		move.b	#0,$ffff820a.w		; 60 Hz
		move.b	d0,$ffff8260.w
		move.l	a0,d0
		lsr.w	#8,d0
		move.l	d0,$ffff8200.w
		moveq	#0,d0
		move.w	#32000/4-1,d1
.cls:		move.l	d0,(a0)+
		dbf	d1,.cls
		move.b	#2,$ffff820a.w		; 50 Hz pour etre sur du chg de res.
	ELSEIF
		move.b	#0,$ffff820a.w		; 60 Hz
		move.b	d0,$ffff8260.w
		move.w	d0,-(sp)
		move.l	a0,-(sp)
		move.l	a0,-(sp)
		move.w	#5,-(sp)
		trap	#14
		lea	12(sp),sp
		move.b	#2,$ffff820a.w		; 50 Hz pour etre sur du chg de res.
	ENDC
		clr.w	$ffff8240.w
		move.w	#$566,$ffff8242.w
		move.w	#$566,$ffff8246.w
		move.w	#$566,$ffff825e.w
		lea	rsZone(pc),a0
		tst.b	BSTE(a0)
		beq.s	.ok
		sf	$ffff820d.w		; Init video.
		sf	$ffff820f.w
		sf	$ffff8265.w
		sf	$ffff8901.w		; Coupe sample-DMA.
.ok:

		movem.l	(sp)+,d0-d1/a0
		rts


;********************************************************
;*							*
;*	isSte						*
;*	Return: d0.b =   0 pour STF			*
;*		d0.b = $ff pour STE			*
;*							*
;********************************************************
isSte:		movem.l	a0-a2,-(sp)
		movea.l	sp,a2
		move.l	$8.w,a1
		lea	.back(pc),a0
		move.l	a0,$8.w
		sf	d0
		movea.w	#$820d,a0
		move.b	#0,(a0)
		addi.b	#8,(a0)
		cmpi.b	#8,(a0)
		bne.s	.back
		subi.b	#8,(a0)
		bne.s	.back
		st	d0
.back:		movea.l	a2,sp
		move.l	a1,$8.w
		movem.l	(sp)+,a0-a2
		rts



txtWaitCommand:	dc.b	10,13,'Waiting command from REMOTE...',10,13,0
txtUnknowCommand: dc.b	'ERROR:Unknow command received !',10,13,0
txtCommandError: dc.b	'ERROR:COMMAND checksum error !',10,13,0
txtCalcChecksum: dc.b	'Computing block checksum...',10,13,0
txtChecksumError: dc.b	'ERROR:BLOCK Checksum ERROR !',10,13,0
txtBlockSave:	dc.b	'Saving binary block as "',0
txtXbiosWriteError:
		dc.b	'ERROR:XBIOS Fwrite ERROR !',10,13,0
txtFileCopy:	dc.b	'Loading file from REMOTE...',0
txtBlockLoad	dc.b	'Loading block from REMOTE...',10,13,0
txtBinaryNoOk:	dc.b	'ERROR:No valid Binary-Block in RAM.',10,13,0
txtDiskCreate	dc.b	'Writing image disk...',10,13,0
		even

lDebug:         incbin	"ldebug.bin"
		even

checksumModify:	dc.w	0

codeEnd:


oldTrap:	ds.l	1

rsZone		ds.b	1	; BOOL STE/STF
		ds.b	1	; BOOL binary Ok, binary FALSE
		ds.l	1	; Adresse ecran.
		ds.l	8
		ds.b	16
		ds.l	1	; Tower AD

tmpPrint	ds.b	12
fName		ds.b	16
commandBuffer:	ds.b	COMMAND_SIZE
binarySize:	ds.l	1
binaryCheck:	ds.w	1
binaryAd:	ds.l	1
binaryMode:	ds.w	1


		ds.l	256
stack:		even

bssEnd:
			end

;------------------------------------------------------------------------
;			END OF FILE.
;------------------------------------------------------------------------
